"use strict";

var SLOPE_ROOM_FORM_SELECTORS = {
  ADULTS: '[data-input="adults"]',
  CHILDREN: '[data-input="children"]'
};

function SlopeGuestsWrapper($element) {
  this.childrenNextIndex = 0;
  this.$element = $element;
  this.stepperContainer = $element.siblings('.slope-stepper-container');
  this.rooms = [new SlopeRoom(0, this.stepperContainer.find('[data-container="guests"]'), this.$element.find(SLOPE_ROOM_FORM_SELECTORS.ADULTS), $element)];

  this.updateGuests = function () {
    var self = this;
    Array.from(this.$element.find('[data-sync-value]')).forEach(function (el) {
      var result = 0;
      Array.from(self.stepperContainer.find('[data-sync-trigger=\"' + el.getAttribute('data-sync-value') + '\"]')).forEach(function (e) {
        result += parseInt(e.value);
      });
      el.textContent = result;
    });
    Array.from(this.$element.find(SLOPE_ROOM_FORM_SELECTORS.ADULTS)).forEach(function (el) {
      el.value = self.stepperContainer.find('[data-sync-trigger="adults"]').val();
    });
    this.rooms.forEach(function (room) {
      return room.update();
    });
  };

  this.reset = function () {
    this.rooms.forEach(function (room, index) {
      if (index > 0) {
        room.destroy();
      }
    });
    this.rooms[0].reset();
    this.rooms = [this.rooms[0]];
    this.stepperContainer.find('[data-sync-trigger="rooms"]').val(1);
    this.stepperContainer.find('[data-sync-trigger="adults"]').val(2);
    this.childrenNextIndex = 0;
    var stepperInput = this.stepperContainer.find('[data-sync-trigger="children"]');
    stepperInput.val(this.childrenNextIndex);
    jQuery('[data-input="children"][name]').remove();
    this.updateGuests();
  };

  this.calculateStepperTop = function () {
    var isMobile = function isMobile() {
      var check = false;

      (function (a) {
        if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0, 4))) check = true;
      })(navigator.userAgent || navigator.vendor || window.opera);

      return check;
    }; // We append the stepper container to the body of the page to avoid z-index to depend on the container


    document.querySelector('body').appendChild(this.stepperContainer[0]);
    var slopeBlockBounds = this.$element.parentsUntil('.slope-block').parent()[0].getBoundingClientRect();
    var top = window.pageYOffset + slopeBlockBounds.top + slopeBlockBounds.height - (isMobile() ? this.$element.parentsUntil('slope-guests-and-button-container').find('.slope-submit-section')[0].getBoundingClientRect().height : 0);
    var left = isMobile() ? slopeBlockBounds.left : window.pageXOffset + slopeBlockBounds.left + slopeBlockBounds.width / 100 * 35;
    this.stepperContainer.css('top', top + 'px');
    this.stepperContainer.css('left', left + 'px');
  };

  this.openGuestsSelection = function () {
    this.stepperContainer.show();
  };

  this.closeGuestsSelection = function () {
    this.stepperContainer.hide();
  };

  this.handleClickOutsideGuestsSelection = function (event) {
    var containers = Array.from(document.querySelectorAll('.slope-stepper-container'));
    var isStepperContainerVisible = this.stepperContainer.css('display') !== 'none';

    if (containers.length > 0 && this.$element.parent().find(event.target).length === 0 && !this.$element.parent().is(event.target) && this.stepperContainer.find(event.target).length === 0 && isStepperContainerVisible) {
      this.updateGuests();
      this.closeGuestsSelection();
    }
  };

  this.init = function ($) {
    this.updateGuests();
    var self = this;
    this.$element.parent().on('click', function (event) {
      if (!self.stepperContainer[0].contains(event.target)) {
        self.openGuestsSelection();
        self.calculateStepperTop();
      }
    });
    $(document).on('click', function (event) {
      self.handleClickOutsideGuestsSelection(event);
    });
    self.stepperContainer.find('.slope-cancel-guests').on('click', function () {
      self.reset();
      self.closeGuestsSelection();
    });
    self.stepperContainer.find('.slope-save-guests').on('click', function () {
      self.updateGuests();
      self.closeGuestsSelection();
    });
    self.stepperContainer.find('[data-increment="rooms"]').on('click', function () {
      if (self.rooms.length > 98) {
        return;
      }

      var adultsInputClone = self.$element.find(SLOPE_ROOM_FORM_SELECTORS.ADULTS).first().clone();
      adultsInputClone.appendTo(self.$element);
      self.rooms.push(new SlopeRoom(self.rooms.length, self.stepperContainer.find('[data-container="guests"]'), adultsInputClone, $element));
      self.stepperContainer.find('[data-sync-trigger="rooms"]').val(self.rooms.length);
    });
    self.stepperContainer.find('[data-decrement="rooms"]').on('click', function () {
      if (self.rooms.length === 1) {
        return;
      }

      self.$element.find(SLOPE_ROOM_FORM_SELECTORS.ADULTS).last().remove();
      var lastRoom = self.rooms.pop();
      self.$element.find('[name^="reservation[guestCounts][' + lastRoom.index + '][childrenAges]"]').remove();
      lastRoom.destroy();
      self.stepperContainer.find('[data-sync-trigger="rooms"]').val(self.rooms.length);
    });
  };
}