<?php
// SLOPE PROMOTIONS

add_shortcode('slope-promotions', 'slope_promotions');

// Content to show with the shortcode [slope-promotions]
function slope_promotions() {
	$options = get_option('slope_options');
	return '<div id="slope-promotions" data-id="' . $options['uuid'] . '"></div>';
}

// Callback slope promotions
function slope_promotions_intro() {
	$options_reservations = get_option('slope_options');
	$options_promotions = get_option('slope_promotions_options');

	//SETTINGS
	echo '<div class="slope-setting-container-promotions"><p>' . esc_html__('Personalizza il widget delle promozioni di Slope. Usa lo ', 'slope-widgets') . 'shortcode <strong>[slope-promotions]</strong> ' . esc_html__('per inserirlo dove vuoi!', 'slope-widgets') . '</p>';
	//Readonly options[uuid]
	echo '<p id="link-change-id">' . esc_html__('Per modificare il tuo ID struttura ', 'slope-widgets') . '<a href="?page=slope_reservations">' . esc_html__('clicca qui', 'slope-widgets') . '</a>.</p>';
	echo "<div class='setting-field'>
    		<label> " . esc_html__('ID struttura', 'slope-widgets') . "<input id='slope_promotions_uuid' name='slope_options[uuid]' size='40' disabled='text' value='{$options_reservations['uuid']}' placeholder='" . esc_html__('Il tuo Slope ID', 'slope-widgets') . "'></label>
    	</div>";

	// Checkbox: slope_promotions_options[hide_description]
	if ($options_promotions['hide_description']) {
		$checkedHideDescription = ' checked="checked" ';
	}

	echo "<div class='setting-field'>
    		<label class='checkbox-hide-description'>  " . esc_html__('Nascondi descrizione delle promozioni', 'slope-widgets') . " <input " . $checkedHideDescription . " id='slope_promotions_hide_description' name='slope_promotions_options[hide_description]' type='checkbox'></label>
    	</div>";

	// Checkbox: slope_promotions_options[hide_information]
	if ($options_promotions['hide_information']) {
		$checkedHideInformation = ' checked="checked" ';
	}

	echo "<div class='setting-field'>
    		<label class='checkbox-hide-information'>" . esc_html__('Nascondi informazioni delle promozioni', 'slope-widgets') . "<input " . $checkedHideInformation . "id='slope_promotions_hide_information' name='slope_promotions_options[hide_information]' type='checkbox'></label>
    	</div>";

	echo '</div>';

	//STYLE
	$options_promotions = get_option('slope_promotions_options');
	echo "<div class='slope-style-container-promotions'>";

	// Colorpicker: options_promotions[promotions_background_color]
	echo "<div class='setting-field'>
    		<label>" . esc_html__('Colore di sfondo delle schede', 'slope-widgets') . "</label>
    		<input id='colorpicker' name='slope_promotions_options[promotions_background_color]' type='text' class='slope_promotions_background_color' value='{$options_promotions['promotions_background_color']}'> 
    	</div>";

	// Colorpicker: options_promotions[promotions_text_color]
	echo "<div class='setting-field'>
    		<label>" . esc_html__('Colore del testo', 'slope-widgets') . "</label>
    		<input id='colorpicker' name='slope_promotions_options[promotions_text_color]' type='text' class='slope_promotions_text_color' value='{$options_promotions['promotions_text_color']}'> 
    	</div>";

	// Colorpicker: options_promotions[promotions_button_background_color]
	echo "<div class='setting-field'>
    		<label>" . esc_html__('Colore del pulsante di prenotazione', 'slope-widgets') . "</label>
    		<input id='colorpicker' name='slope_promotions_options[promotions_button_background_color]' type='text' class='slope_promotions_button_background_color' value='{$options_promotions['promotions_button_background_color']}'> 
    	</div>";

	// Colorpicker: options_promotions[promotions_button_text_color]
	echo "<div class='setting-field'>
    		<label>" . esc_html__('Colore del testo del pulsante di prenotazione', 'slope-widgets') . "</label>
    		<input id='colorpicker' name='slope_promotions_options[promotions_button_text_color]' type='text' class='slope_promotions_button_text_color' value='{$options_promotions['promotions_button_text_color']}'> 
    	</div>";

	// Colorpicker: options_promotions[promotions_title_color]
	echo "<div class='setting-field'>
    		<label>" . esc_html__('Colore del titolo', 'slope-widgets') . "</label>
    		<input id='colorpicker' name='slope_promotions_options[promotions_title_color]' type='text' class='slope_promotions_title_color' value='{$options_promotions['promotions_title_color']}'> 
    	</div>";

	// Colorpicker: options_promotions[promotions_border_color]
	echo "<div class='setting-field'>
    		<label>" . esc_html__('Colore dei bordi delle schede', 'slope-widgets') . "</label>
    		<input id='colorpicker' name='slope_promotions_options[promotions_border_color]' type='text' class='slope_promotions_border_color' value='{$options_promotions['promotions_border_color']}'> 
    	</div>";

	// Text field: options_promotions[promotions_border_size]
	echo "<div class='style-field'>
    		<label>" . esc_html__('Spessore dei bordi delle schede (px)', 'slope-widgets') . "</label>
    		<input id='slope_promotions_border_size' class='border-size-promotions' name='slope_promotions_options[promotions_border_size]' type='number' min='0' max='6' value='{$options_promotions['promotions_border_size']}' placeholder='0'> 
    	</div>";

	// Radio: options_promotions[align_title]
	echo "<div class='style-field radio-field'>";
	$items = array(
		SLOPE_PROMOTIONS_ALIGN_CENTER => esc_html__('Centro', 'slope-widgets'),
		SLOPE_PROMOTIONS_ALIGN_LEFT => esc_html__('Sinistra', 'slope-widgets'),
		SLOPE_PROMOTIONS_ALIGN_RIGHT => esc_html__('Destra', 'slope-widgets'),
	);
	echo "<label class='style-field' >" . esc_html__('Allineamento del titolo', 'slope-widgets') . "<br/></label>";
	foreach ($items as $value => $item) {
		$checkedAlign = ($options_promotions['align_title'] == $value) ? ' checked="checked" ' : '';
		echo "<input " . $checkedAlign . " value='$value' name='slope_promotions_options[align_title]' type='radio' />$item<br/>";
	}
	echo "</div>";

	// Text field: options_promotions[title_size]
	echo "<div class='style-field'>
    		<label>" . esc_html__('Dimensione del titolo ', 'slope-widgets') . " (<input id='text_title_size' readonly='text' class='slope_promotions_title_size' value='{$options_promotions['title_size']}' />px)</label>
    		<input id='title_size' min='0' max='35' name='slope_promotions_options[title_size]' type='range' class='slope_promotions_title_size' value='{$options_promotions['title_size']}' onchange='text_title_size.value=value' />
    	</div>";

	// Text field: options_promotions[border_radius]
	echo "<div class='style-field'>
    		<label>" . esc_html__('Smussatura degli angoli delle schede ', 'slope-widgets') . " (<input id='text_border_radius' readonly='text' class='slope_promotions_border_radius' value='{$options_promotions['border_radius']}' />px)
    		</label>
    		<input id='border_radius' min='0' max='40' name='slope_promotions_options[border_radius]' type='range' class='slope_promotions_border_radius' value='{$options_promotions['border_radius']}' onchange='text_border_radius.value=value' />
    </div></div>";

	//LAYOUT
	echo "<div class='slope-layout-container-promotions'>";

	//Radio: options_promotions[option_set]
	echo "<div class='radio-field'>";
	$items = array(
		'SLOPE_PROMOTIONS_LAYOUT_ONE_CARD' => esc_html__('1', 'slope-widgets'),
		'SLOPE_PROMOTIONS_LAYOUT_TWO_CARD' => esc_html__('2', 'slope-widgets'),
		'SLOPE_PROMOTIONS_LAYOUT_THREE_CARD' => esc_html__('3', 'slope-widgets'),
		'SLOPE_PROMOTIONS_LAYOUT_FOUE_CARD' => esc_html__('4', 'slope-widgets'),
	);
	echo "<label class='layout-field'>" . esc_html__('Numero di schede da mostrare per riga', 'slope-widgets') . "<br/></label>";
	foreach ($items as $value => $item) {
		$checkedLayoutProm = ($options_promotions['option_set'] == $value) ? ' checked="checked" ' : '';
		echo "<input " . $checkedLayoutProm . " value='$value' name='slope_promotions_options[option_set]' type='radio' />$item<br/>";
	}
	echo "</div></div>";
}

// Shows the admin page of PROMOTIONS options
function slope_promotions_options_page() {
	echo '<div class="wrap">
    <h1 class="title-promotions">Slope Promotions</h1>'; ?>
	<?php settings_errors(); ?>
	<form id="promotions" action="options.php" method="post">
		<h2 class="nav-tab-wrapper">
			<a id='setting_page_promotions_select' href='#' class='nav-tab nav-tab-active' onclick='activate_page_setting_promotions()'>
				<?php esc_attr_e('Impostazioni', 'slope-widgets') ?>
			</a>
			<a id='style_page_promotions_select' href='#' class='nav-tab' onclick='activate_page_style_promotions()'>
				<?php esc_attr_e('Stile', 'slope-widgets') ?>
			</a>
			<a id='layout_page_promotions_select' href='#' class='nav-tab' onclick='activate_page_layout_promotions()'>
				<?php esc_attr_e('Layout', 'slope-widgets') ?>
			</a>
		</h2>
		<?php settings_fields('slope_promotions_options'); ?>
		<?php do_settings_sections('slope_promotions_page'); ?>
		<p class="submit">
			<input name="Submit" type="submit" class="button-primary" value="<?php esc_attr_e('Salva modifiche', 'slope-widgets'); ?>" />
		</p>
	</form>
</div>
<?php
}

function slope_promotions_style() {
	$options_promotions = get_option('slope_promotions_options'); 

	$defaultPromotionsBgColor = '#fbfbfb';
	$defaultPromotionsBoderSize = '1';
	$defaultPromotionsBorderColor = '#ccc';
	$defaultPromotionsBorderRadius = '5';
	$defaultPromotionsButtonBgColor = '#277fbe';
	$defaultPromotionsButtonColor = '#fff';
	$defaultPromotionsColor = '#111';
	$defaultPromotionsTitleColor = '#111';
	$defaultPromotionsTitleSize = '22';

	$promotionsBgColor = ($options_promotions['promotions_background_color'] ? $options_promotions['promotions_background_color'] : $defaultPromotionsBgColor);
	$promotionsBorderColor = ($options_promotions['promotions_border_color'] ? $options_promotions['promotions_border_color'] : $defaultPromotionsBorderColor);
	$promotionsBorderRadius = ($options_promotions['border_radius'] ? $options_promotions['border_radius'] : $defaultPromotionsBorderRadius);
	$promotionsBorderThickness = ($options_promotions['promotions_border_size'] ? $options_promotions['promotions_border_size'] : $defaultPromotionsBoderSize);
	$promotionsButtonBgColor = ($options_promotions['promotions_button_background_color'] ? $options_promotions['promotions_button_background_color'] : $defaultPromotionsButtonBgColor);
	$promotionsButtonColor = ($options_promotions['promotions_button_text_color'] ? $options_promotions['promotions_button_text_color'] : $defaultPromotionsButtonColor);
	$promotionsColor = ($options_promotions['promotions_text_color'] ? $options_promotions['promotions_text_color'] : $defaultPromotionsColor);
	$promotionsTitleColor = ($options_promotions['promotions_title_color'] ? $options_promotions['promotions_title_color'] : $defaultPromotionsTitleColor);
	$promotionsTitleSize = ($options_promotions['title_size'] ? $options_promotions['title_size'] : $defaultPromotionsTitleSize);
	?>
	<style>
		.slp-column p,
		.slp td {
			color: <?php echo $promotionsColor ?> !important;
		}

		a.slp-button {
			background: <?php echo $promotionsButtonBgColor ?> !important;
			color: <?php echo $promotionsButtonColor ?> !important;
		}

		p.slp-title {
			color: <?php echo $promotionsTitleColor ?> !important;
			font-size: <?php echo $promotionsTitleSize ?>px !important;
		}

		.slp-column {
			border: <?php echo $promotionsBorderThickness ?>px solid <?php echo $promotionsBorderColor ?> !important;
			background: <?php echo $promotionsBgColor ?> !important;
		}

		.slp-column,
		a.slp-button {
			border-radius: <?php echo $promotionsBorderRadius ?>px !important;
		}

		<?php if ($options_promotions['hide_description']) { ?>
			.slp-column .slp-title {
				display: block !important;
			}

			.slp-column p {
				display: none !important;
			}
		<?php } if ($options_promotions['hide_information']) { ?>
			.slp td {
				display: none !important;
			}
		<?php
	} ?>
	</style>
	<?php
}

// Title alignment
function slope_promotions_title_align() {
	$options_promotions = get_option('slope_promotions_options');
	if ($options_promotions['align_title'] == 'SLOPE_PROMOTIONS_ALIGN_CENTER') {
		echo "<style> p.slp-title { text-align: center !important; } </style>";
	} else if ($options_promotions['align_title'] == 'SLOPE_PROMOTIONS_ALIGN_LEFT') {
		echo "<style> p.slp-title { text-align: left !important; } </style>";
	} else if ($options_promotions['align_title'] == 'SLOPE_PROMOTIONS_ALIGN_RIGHT') {
		echo "<style> p.slp-title { text-align: right !important; } </style>";
	}
}

// Cards layout
function slope_promotions_layout_select() {
	$options_promotions = get_option('slope_promotions_options');
	if ($options_promotions['option_set'] == 'SLOPE_PROMOTIONS_LAYOUT_ONE_CARD') {
		echo "<style> .slp-row .slp-column-4 {
						max-width: 500px !important;
						margin-bottom: 2rem !important;
						width: 100% !important;
						margin-left: 1.6% !important;
					} </style>";
	} else if ($options_promotions['option_set'] == 'SLOPE_PROMOTIONS_LAYOUT_TWO_CARD') {
		echo "<style> .slp-row .slp-column-4 {
						max-width: 500px !important;
						margin-bottom: 2rem !important;
						width: 40% !important;
						margin-left: 1.6% !important;
					} </style>";
	} else if ($options_promotions['option_set'] == 'SLOPE_PROMOTIONS_LAYOUT_THREE_CARD') {
		echo "<style> .slp-row .slp-column-4 {
						max-width: 500px !important;
						margin-bottom: 2rem !important;
						width: 30.3% !important;
						margin-left: 1.6% !important;
					} </style>";
	} else if ($options_promotions['option_set'] == 'SLOPE_PROMOTIONS_LAYOUT_FOUR_CARD') {
		echo "<style> .slp-row .slp-column-4 {
						max-width: 500px !important;
						margin-bottom: 2rem !important;
						width: 25% !important;
						margin-left: 1.6% !important;
					} </style>";
	}
}
