"use strict";

function SlopeForm($form, requiredFields) {
  this.data = _toJSON($form);
  this.requiredFields = requiredFields;

  this.isValid = function () {
    var self = this;
    return this.requiredFields.map(function (field) {
      return self.data.hasOwnProperty(field) && !!self.data[field];
    }).reduce(function (prev, current) {
      return prev && current;
    });
  };

  function _toJSON($form) {
    var asArray = $form.serializeArray();
    var json = {};
    asArray.forEach(function (el) {
      json[el.name] = el.value;
    });
    return json;
  }

  this.send = function (url, successCallback) {
    jQuery.ajax(url, {
      type: "POST",
      data: JSON.stringify(this.data),
      success: successCallback
    });
  };
}